package openfrontiers;


/**
 * An ArrayList class with more features and useability.
 * @author ObsequiousNewt
 */
public class ArrayList<E> extends java.util.ArrayList<E>{
	private static final long serialVersionUID = 1774404015197020823L;
	
	public ArrayList(){
		/* if I don't do this, I get "unchecked" warnings- because it 
		 * tries to call the latter constructor first, and 
		 * ArrayList<Object>() fits its pattern. -Newt
		 */
		super();
	}

	public ArrayList(E... x){
		super();
		addAll(x);
	}
	public void addAll(E... x){
		for(E i:x){
			add(i);
		}
	}
	public E get(int index){
		return super.get(index);
	}
	public int get_cube(int index){
		if(index >= this.size()){
			return 0;
		}else if(index<0){
			return -1;
		}else{
			return (Integer) get(index);
		}
	}
}
