package openfrontiers;

import openfrontiers.err.AssertError;

public final class builtins {
	public static ArrayList<Integer> range(int len){
		return range(0,len,1);
	}
	public static ArrayList<Integer> range(int start, int end){
		return range(start,end,1);
	}
	public static ArrayList<Integer> range(int start, int end, int step){
		ArrayList<Integer> array = new ArrayList<Integer>();
		for(int i=start;i<end;i+=step){
			array.add(i);
		}
		return array;
	}
	/**
	 * @param xdim - length of x dimension
	 * @param ydim - length of y dimension
	 * @return an empty 3-dimensional matrix with specified x and y dimensions
	 */
	public static ArrayList<ArrayList<ArrayList<Integer>>> matrix3(int xdim, int ydim){
		System.out.print("Building matrix... ");
		ArrayList<ArrayList<ArrayList<Integer>>> m = new ArrayList<ArrayList<ArrayList<Integer>>>();
		for(int i=0; i<xdim; i++){
			ArrayList<ArrayList<Integer>> x = new ArrayList<ArrayList<Integer>>();
			m.add(x);
			for(int j=0;j<ydim;j++){
				ArrayList<Integer> y = new ArrayList<Integer>();
				x.add(y);
			}
		}
		System.out.println("done");
		return m;
	}
	/**
	 * @param x - length of x dimension
	 * @param y - length of y dimension
	 * @return an empty 2-dimensional matrix
	 */
	public static ArrayList<ArrayList<Integer>> matrix2(long x,long y){
		ArrayList<ArrayList<Integer>> m = new ArrayList<ArrayList<Integer>>();
		for(int i=0; i<x; i++){
			ArrayList<Integer> row = new ArrayList<Integer>();
			m.add(row);
			for(int j=0;j<y;j++){
				row.add(null);
			}
		}
		return m;
	}
	public static void Assert(boolean x) throws AssertError{
		if(!x){
			throw new AssertError(x);
		}
	}
	public static void Assert(Object x) throws AssertError{
		if(!(Boolean) x){
			throw new AssertError(x);
		}
	}
}
