package openfrontiers.game;

import java.io.Serializable;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import openfrontiers.ArrayList;
import openfrontiers.oflib;
import openfrontiers.game.util.tile;

@SuppressWarnings("unused")
public class plane implements Serializable{
	public static final long serialVersionUID = -4709263350608891460L;
	public tile[] tiles;
	public byte[] hash;
	public byte pointer = 0;
	public MessageDigest md;
	public String name;
	
	public plane(String seed){
		try {
			md = MessageDigest.getInstance("SHA-512");
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		}
		md.update(seed.getBytes());
		hash = md.digest();
	}
	public int prnd(){
		int n = hash[pointer];
		if(n<0){
			n += 255;
		}
		pointer++;
		if(pointer==64){
			md.update(hash);
			hash = md.digest();
			pointer = 0;
		}
		return n;
	}
	/**
	 * @param isAbsolute - true if the location specified by x and z is absolute, false if it is the x- and z- offset
	 */
	public tile get_tile(int x, int z,boolean isAbsolute){
		if(isAbsolute){
			x = x/oflib.dim_tile;
			z = z/oflib.dim_tile;
		}
		for(tile t:tiles){
			try{
				if((t.xoff == x) && (t.zoff == z)){
					return t;
				}
			}catch(NullPointerException e){
				System.out.println(x+" "+z);
				throw(e);
			}
		}
		return null;
	}
	public void build_tile(int xoff,int zoff){
		tile t = get_tile(xoff,zoff,false);
	}
	public void load_tile(int xoff,int zoff){
	}
	public void save_tile(int xoff,int zoff){
		tile t = get_tile(xoff,zoff,false);
	}
	
	public int get(int x, int y, int z) {
		if((x<0) || (z<0) || (x>=oflib.dim_total) || (z>=oflib.dim_total)){
			return -1;
		}else{
			tile t = get_tile(x,z,true);
			x -= (t.xoff*oflib.dim_tile);
			z -= (t.zoff*oflib.dim_tile);
			return t.get(x).get(z).get_cube(y);
		}
	}
	
	public int get_column_size(int x, int z){
		if((x<0) || (z<0) || (x>=oflib.dim_total) || (z>=oflib.dim_total)){
			return 0;
		}else{
			tile t = get_tile(x,z,true);
			x -= (t.xoff*oflib.dim_tile);
			z -= (t.zoff*oflib.dim_tile);
			return t.get(x).get(z).size();
		}
	}
	
	public void set(int x, int y, int z, int id) {
		int old = this.get(x, y, z);
		if(old > 0){
			tile t = get_tile(x,z,true);
			x -= (t.xoff*oflib.dim_tile);
			z -= (t.zoff*oflib.dim_tile);
			ArrayList<Integer> q = t.get(x).get(z);
			if(y == q.size()-1){
				q.remove(y);
			}else{
				q.set(y, id);
			}
		}
	}
}
