package openfrontiers.game.psycho;

import openfrontiers.game.plane;
import openfrontiers.game.util.tile;
import openfrontiers.newtjogl.renderable;

public abstract class psycho implements renderable{
	
	public double x,y,z;
	public plane plane;
	public double speed;
	/**
	 * @Deprecated Use <code>set_target(x,z);</code>
	 */
	public int targetx = (int)x,targetz = (int)z;
	public double sinphi,cosphi;
	
	public tile get_tile(){
		return this.plane.get_tile((int)x,(int)z,true);
	}
	
	public void move(){
		double diffx = speed*cosphi, diffz = speed*sinphi;
		double xd = Math.abs(x-(targetx+.5)), zd = Math.abs(z-(targetz+.5));
		if((xd < diffx) || (zd < diffz)){
			x = targetx+.5;
			z = targetz+.5;
			y = get_tile().get_plane().get_column_size(targetx, targetz);
		}else{
			x += diffx;
			z += diffz;
			y = get_tile().get_plane().get_column_size((int)x,(int)z);
		}
	}
	
	public void set_target(int x,int z){
		this.targetx = x;
		this.targetz = z;
		double phi = Math.atan((this.z-(targetz+.5))/(this.x-(targetx+.5))); 
		sinphi = Math.sin(phi)*((targetx<this.x) ? -1 : 1);
		cosphi = Math.cos(phi)*((targetx<this.x) ? -1 : 1);
	}
}
