package openfrontiers.newtjogl;

import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.media.opengl.GL2;
import javax.media.opengl.GLCapabilities;
import javax.media.opengl.GLProfile;
import javax.media.opengl.awt.GLCanvas;

import com.jogamp.opengl.util.texture.Texture;

public abstract class nj{
	public static GLProfile glp;
	public static GLCapabilities caps;
	public static GLCanvas canvas;
	public static Frame frame;
	public static boolean fullscreen = false;
	public static scene s;

    public static void initialize(){
    	glp = GLProfile.getDefault();
        caps = new GLCapabilities(glp);
        canvas = new GLCanvas(caps);

        frame = new Frame("OpenFrontiers");
        frame.setSize(300, 300);
        frame.add(canvas);
        frame.setLocationRelativeTo(null);
        frame.setVisible(true);
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
            	canvas.destroy();
            	frame.dispose();
            }
        });
        s = new scene();
        canvas.addGLEventListener(s);
        canvas.addKeyListener(s);
        canvas.addMouseListener(s);
        canvas.setFocusable(true);
        canvas.requestFocus();
    }
    public static void render_cube(GL2 gl, int x, int y, int z){
    	gl.glLoadIdentity();
    	gl.glTranslatef(x, y, z);
    	gl.glBegin(GL2.GL_QUADS);
			//Top
			gl.glNormal3f(0, 1, 0);
			gl.glVertex3f(1, 1, -1);
			gl.glVertex3f(-1, 1, -1);
			gl.glVertex3f(-1, 1, 1);
			gl.glVertex3f(1, 1, 1);
			//Bottom
			gl.glNormal3f(0, -1, 0);
			gl.glVertex3f(1, -1, 1);
			gl.glVertex3f(-1, -1, 1);
			gl.glVertex3f(-1, -1, -1);
			gl.glVertex3f(1, -1, -1);
			//Front
			gl.glNormal3f(0, 0, 1);
			gl.glVertex3f(1, 1, 1);
			gl.glVertex3f(-1, 1, 1);
			gl.glVertex3f(-1, -1, 1);
			gl.glVertex3f(1, -1, 1);
			//Back
			gl.glNormal3f(0, 0, -1);
			gl.glVertex3f(1, -1, -1);
			gl.glVertex3f(-1, -1, -1);
			gl.glVertex3f(-1, 1, -1);
			gl.glVertex3f(1, 1, -1);
			//Left
			gl.glNormal3f(-1, 0, 0);
			gl.glVertex3f(-1, 1, 1);
			gl.glVertex3f(-1, 1, -1);
			gl.glVertex3f(-1, -1, -1);
			gl.glVertex3f(-1, -1, 1);
			//Right
			gl.glNormal3f(1, 0, 0);
			gl.glVertex3f(1, 1, -1);
			gl.glVertex3f(1, 1, 1);
			gl.glVertex3f(1, -1, 1);
			gl.glVertex3f(1, -1, -1);
		gl.glEnd();
    }
    public static void render_cube(GL2 gl, int x, int y, int z, Texture tex){
    	gl.glLoadIdentity();
    	gl.glTranslatef(x, y, z);
    	tex.enable(gl);
    	tex.bind(gl);
    	gl.glBegin(GL2.GL_QUADS);
		//Top
		gl.glNormal3f(0, 1, 0);
		gl.glTexCoord2f(1,1);	gl.glVertex3f(1, 1, -1);
		gl.glTexCoord2f(0,1);	gl.glVertex3f(-1, 1, -1);
		gl.glTexCoord2f(0,0);	gl.glVertex3f(-1, 1, 1);
		gl.glTexCoord2f(1,0);	gl.glVertex3f(1, 1, 1);
		//Bottom
		gl.glNormal3f(0, -1, 0);
		gl.glTexCoord2f(0,0);	gl.glVertex3f(1, -1, 1);
		gl.glTexCoord2f(1,0);	gl.glVertex3f(-1, -1, 1);
		gl.glTexCoord2f(1,1);	gl.glVertex3f(-1, -1, -1);
		gl.glTexCoord2f(0,1);	gl.glVertex3f(1, -1, -1);
		//Front
		gl.glNormal3f(0, 0, 1);
		gl.glTexCoord2f(1,1);	gl.glVertex3f(1, 1, 1);
		gl.glTexCoord2f(0,1);	gl.glVertex3f(-1, 1, 1);
		gl.glTexCoord2f(0,0);	gl.glVertex3f(-1, -1, 1);
		gl.glTexCoord2f(1,0);	gl.glVertex3f(1, -1, 1);
		//Back
		gl.glNormal3f(0, 0, -1);
		gl.glTexCoord2f(0,0);	gl.glVertex3f(1, -1, -1);
		gl.glTexCoord2f(1,0);	gl.glVertex3f(-1, -1, -1);
		gl.glTexCoord2f(1,1);	gl.glVertex3f(-1, 1, -1);
		gl.glTexCoord2f(0,1);	gl.glVertex3f(1, 1, -1);
		//Left
		gl.glNormal3f(-1, 0, 0);
		gl.glTexCoord2f(1,1);	gl.glVertex3f(-1, 1, 1);
		gl.glTexCoord2f(0,1);	gl.glVertex3f(-1, 1, -1);
		gl.glTexCoord2f(0,0);	gl.glVertex3f(-1, -1, -1);
		gl.glTexCoord2f(1,0);	gl.glVertex3f(-1, -1, 1);
		//Right
		gl.glNormal3f(1, 0, 0);
		gl.glTexCoord2f(1,1);	gl.glVertex3f(1, 1, -1);
		gl.glTexCoord2f(0,1);	gl.glVertex3f(1, 1, 1);
		gl.glTexCoord2f(0,0);	gl.glVertex3f(1, -1, 1);
		gl.glTexCoord2f(1,0);	gl.glVertex3f(1, -1, -1);
	gl.glEnd();
    }
}