package openfrontiers.newtjogl;

import static openfrontiers.builtins.range;

import java.awt.Font;
import java.awt.Frame;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.media.opengl.DebugGL2;
import javax.media.opengl.GL;
import javax.media.opengl.GL2;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLEventListener;
import javax.media.opengl.awt.GLCanvas;
import javax.media.opengl.glu.GLU;

import openfrontiers.ArrayList;
import openfrontiers.err.NoCubeHereError;
import openfrontiers.event.event_carve;
import openfrontiers.event.event_move;
import openfrontiers.event.eventserver;
import openfrontiers.game.plane;
import openfrontiers.game.db.cubedb;
import openfrontiers.game.psycho.player;

import com.jogamp.opengl.util.Animator;
import com.jogamp.opengl.util.awt.TextRenderer;

public class scene implements GLEventListener,KeyListener,MouseListener{
	public GL2 gl;
	public GLU glu = new GLU();
	public GLCanvas canvas = nj.canvas;
	public Animator animator;
	public static int filter = 1;
	public plane world;
	public ArrayList<square> squares = new ArrayList<square>();
	public player p;
	
	//Used for text
	public int fontdisp;
	public TextRenderer tr;
	public String text;
	public int txtx,txty;
	
	public long mousetime;
	
	//Used for lighting
	public boolean light = false;
	public static final float[] ambient = {.5f,.5f,.5f,1};
	public static final float[] diffuse = {1,1,1,1};
	public static final float[] position = {0,0,2,1};
	
	//Used to calculate camera coordinates
	public double ex,ey,ez;
	public double cx=.5,cy,cz=.5;
	public double theta = Math.PI/2;
	public double phi = 0;
	public double dist = 1;
	public int rd = 16;
	public double[] x1,x2;
	
	@Override
	public void display(GLAutoDrawable drawable){
		gl = drawable.getGL().getGL2();
		gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);
		gl.glLoadIdentity();
		if(light){
			gl.glEnable(GL2.GL_LIGHTING);
		}else{
			gl.glDisable(GL2.GL_LIGHTING);
		}
		ex = (Math.sin(theta)*Math.sin(phi)*dist)+cx;
		ey = (Math.cos(theta)*dist)+cy;
		ez = (Math.sin(theta)*Math.cos(phi)*dist)+cz;
		glu.gluLookAt(ex, ey, ez, cx, cy, cz, 0, 1, 0);
		squares.clear();
		p.move();
		p.render(gl);
		for(int x=(int) (cx-rd);x<(cx+rd);x++){
			for(int z=(int) (cz-rd);z<(cz+rd);z++){
				for(int y=0;y<world.get_column_size(x,z);y++){
					square.render_cube(world, x, y, z, gl);
				}
			}
		}
		eventserver.server.execute();
		text = cx+","+cy+","+cz;
		tr.beginRendering(drawable.getWidth(), drawable.getHeight());
		tr.setColor(1,1,1,.5f);
		tr.draw(text, txtx, txty);
		tr.endRendering();
		cy = world.get_column_size((int)cx, (int)cz);
	}
	
	@Override
	public void dispose(GLAutoDrawable drawable){
	}
	
	@Override
	public void init(GLAutoDrawable drawable){
		gl = drawable.getGL().getGL2();
		drawable.setGL(new DebugGL2(gl));
		gl.glEnable(GL.GL_TEXTURE_2D);
		gl.glShadeModel(GL2.GL_SMOOTH);
		gl.glClearColor(0, 0, 0, 1);
		gl.glClearDepth(1);
		gl.glEnable(GL.GL_DEPTH_TEST);
		gl.glDepthFunc(GL.GL_LEQUAL);
		gl.glHint(GL2.GL_PERSPECTIVE_CORRECTION_HINT, GL.GL_NICEST);
		//Lighting
		gl.glLightfv(GL2.GL_LIGHT1, GL2.GL_AMBIENT, ambient,0);
		gl.glLightfv(GL2.GL_LIGHT1, GL2.GL_DIFFUSE, diffuse,0);
		gl.glLightfv(GL2.GL_LIGHT1, GL2.GL_POSITION, position,0);
		gl.glEnable(GL2.GL_LIGHT1);
		gl.glDisable(GL2.GL_LIGHTING);
		//Textures
		gl.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER, GL.GL_NEAREST);
		gl.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER, GL.GL_NEAREST);
		cubedb.init_tex(gl);
		//Fonts
		tr = new TextRenderer(new Font("Monospace",Font.BOLD,14));
//		Rectangle2D bounds = tr.getBounds(text+"0000.00");
//		int width = (int) bounds.getWidth();
//		int height = (int) bounds.getHeight();
		txtx = 5; //(drawable.getWidth()-width)/2;
		txty = 5; //(drawable.getHeight()-height)/2;
		
		cy = world.get_column_size((int)cx, (int)cz);
		p.x = cx;
		p.y = cy;
		p.z = cz;
	}
	
	public void start(){
		animator = new Animator(canvas);
		animator.start();
	}
	
	public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height){
		gl.glViewport(0,0,width,height);
		gl.glMatrixMode(GL2.GL_PROJECTION);
		gl.glLoadIdentity();
		glu.gluPerspective(45, ((float)width)/((float)height), .1F,100);
		gl.glMatrixMode(GL2.GL_MODELVIEW);
		gl.glLoadIdentity();
	}
	
	public void keyPressed(KeyEvent e){
		int keycode = e.getKeyCode();
		switch(keycode){
		case KeyEvent.VK_PAGE_UP:
			dist--;
			break;
		case KeyEvent.VK_PAGE_DOWN:
			dist++;
			break;
		case KeyEvent.VK_END:
			rd++;
			break;
		case KeyEvent.VK_HOME:
			rd--;
			break;
		case KeyEvent.VK_LEFT:
			phi -= 0.1;
			break;
		case KeyEvent.VK_UP:
			theta -= 0.1;
			break;
		case KeyEvent.VK_RIGHT:
			phi += 0.1;
			break;
		case KeyEvent.VK_DOWN:
			theta += 0.1;
			break;
		case KeyEvent.VK_A:
			cx--;
			break;
		case KeyEvent.VK_D:
			cx++;
			break;
		case KeyEvent.VK_E:
			cy--;
			break;
		case KeyEvent.VK_F:
			filter += 1;
			if(filter>9){
				filter=1;
			}
			break;
		case KeyEvent.VK_L:
			light = !light;
			break;
		case KeyEvent.VK_Q:
			cy++;
			break;
		case KeyEvent.VK_S:
			cz++;
			break;
		case KeyEvent.VK_W:
			cz--;
			break;
		case KeyEvent.VK_F1:
			nj.frame.dispose();
			nj.frame.setUndecorated(!nj.fullscreen);
			if(nj.fullscreen){
				nj.frame.setExtendedState(Frame.NORMAL);
				nj.frame.setSize(300,300);
				nj.frame.setLocationRelativeTo(null);
			}else{
				nj.frame.setExtendedState(Frame.MAXIMIZED_BOTH);
			}
			nj.frame.setVisible(true);
			nj.fullscreen = !nj.fullscreen;
			break;
		}
	}
	
	public void keyReleased(KeyEvent arg0){
	}
	
	public void keyTyped(KeyEvent e){
	}
	
	public double[] get3dmousepos(double winz) throws NoCubeHereError{
		int[] viewport = new int[4];
		double[] modelview = new double[16];
		double[] projection = new double[16];
		double[] wcoord = new double[4];
		gl.glGetIntegerv(GL.GL_VIEWPORT, viewport,0);
		gl.glGetDoublev(GL2.GL_MODELVIEW_MATRIX, modelview,0);
		gl.glGetDoublev(GL2.GL_PROJECTION_MATRIX, projection,0);
		Point p = nj.canvas.getMousePosition();
		if(p != null){
			int x = p.x, y = (viewport[3] - p.y - 1);
			glu.gluUnProject((double) x,(double) y,winz,modelview,0,projection,0,viewport,0,wcoord,0);
			return wcoord;
		}else{
			throw new NoCubeHereError();
		}
	}
	
	public Integer[] firstcubeonmouse() throws NoCubeHereError{
		ArrayList<square> candidates = new ArrayList<square>();
		double[] x1 = this.get3dmousepos(0);
		double[] x2 = this.get3dmousepos(1);
		for(square s:squares){
			if(world.get(s.x, s.y, s.z) != 0){
				if(s.crosses(x1,x2)){
					candidates.add(s);
				}
			}
		}
		if(candidates.size()>0){
			double shortest = 10000.0;
			int pos = -1;
			for(int c:range(candidates.size())){
				double dist = Math.sqrt(Math.pow(candidates.get(c).x-x1[0],2)+Math.pow(candidates.get(c).y-x1[1],2)+Math.pow(candidates.get(c).z-x1[2], 2));
				if(dist < shortest){
					shortest = dist;
					pos = c;
				}
			}
			return new Integer[]{candidates.get(pos).x,candidates.get(pos).y,candidates.get(pos).z};
		}else{
			throw new NoCubeHereError();
		}
	}
	
	public void mouseClicked(MouseEvent e){
	}
	
	public void mouseEntered(MouseEvent e){
	}
	
	public void mouseExited(MouseEvent e){
	}
	
	public void mousePressed(MouseEvent e){
		this.mousetime = e.getWhen();
	}
	
	public void mouseReleased(MouseEvent e){
		long time = e.getWhen() - this.mousetime;
		if(time<1000){
			switch(e.getButton()){
			case MouseEvent.BUTTON1:
				eventserver.server.queue.add(new event_carve());
				break;
			case MouseEvent.BUTTON3:
				eventserver.server.queue.add(new event_move(p));
				break;
			}
		}else{
			//TODO Open the menu on the selected object
		}
	}
}
