package openfrontiers.newtjogl;

import javax.media.opengl.GL2;

import openfrontiers.game.plane;
import openfrontiers.game.db.cubedb;

import com.jogamp.opengl.util.texture.Texture;

public abstract class square{
	public int x,y,z,d;
	public square(int x, int y, int z, int d){
		this.x = x;
		this.y = y;
		this.z = z;
		this.d = d;
		this.render(nj.s.gl);
	}
	public abstract void render(GL2 gl);
	
	public abstract boolean crosses(double[] x1, double[] x2);

	public static void render_cube(plane p, int x, int y, int z,GL2 gl){
		int q = p.get(x, y, z);
		if(q != 0){
			Texture t = null;
			if(q != scene.filter){
				scene.filter = q;
				t = cubedb.tex.get(q);
				if(t != null){
					t.enable(gl);
					t.bind(gl);
				}
			}
			gl.glBegin(GL2.GL_QUADS);
			//Left
			if(p.get(x-1, y, z) == 0){
				nj.s.squares.add(new squarex(x,y,z,x));
			}
			//Right
			if(p.get(x+1, y, z) == 0){
				nj.s.squares.add(new squarex(x,y,z,x+1));
			}
			//Bottom
			if(p.get(x, y-1, z) == 0){
				nj.s.squares.add(new squarey(x,y,z,y));
			}
			//Top
			if(p.get(x, y+1, z) == 0){
				nj.s.squares.add(new squarey(x,y,z,y+1));
			}
			//Front
			if(p.get(x, y, z+1) == 0){
				nj.s.squares.add(new squarez(x,y,z,z+1));
			}
			//Back
			if(p.get(x, y, z-1) == 0){
				nj.s.squares.add(new squarez(x,y,z,z));
			}
			gl.glEnd();
		}
	}
}
