package openfrontiers;

import static openfrontiers.builtins.*;

public abstract class oflib{
	///////////////////////////// # Constants # ////////////////////////////
	public static final int dim_tile = 64;
	public static final int dim_total = 512;
	public static final int blur_displacement = 64;
	public static final String OS = System.getProperty("os.name");
	public static final String save_path = get_save_path();
	public static String get_save_path(){
		if(OS=="Linux"){
			return "/home/"+System.getProperty("user.name")+"/.openfrontiers/";
		}
		else{
			return System.getProperty("APPDATA");
		}
	}
	/**
	 * @param array - the array to be blurred
	 * @return A Gaussian blur of a two-dimensional array.
	 */
	public static ArrayList<ArrayList<Integer>> gauss(ArrayList<ArrayList<Integer>> array){
		int i = 1;
		int TD = array.size();
		ArrayList<ArrayList<Integer>> array2 = matrix2(TD,TD);
		int x = ((array.get(0).get(0)*10)+(array.get(0).get(1)*4)+(array.get(1).get(0)*4)+(array.get(1).get(1)))/19;
		array2.get(0).set(0,x);
		for(int j=1;j<TD-1;j++){
			x = ((array.get(0).get(j)*10)+(array.get(0).get(j-1)*4)+(array.get(0).get(j+1)*4)+(array.get(1).get(j-1))+(array.get(1).get(j)*4)+(array.get(1).get(j+1)))/24;
			array2.get(0).set(j,x);
		}
		x = ((array.get(0).get(TD-1)*10)+(array.get(0).get(TD-2)*4)+(array.get(1).get(TD-1)*4)+(array.get(1).get(TD-2)))/19;
		array2.get(0).set(TD-1,x);
		for(i=1;i<TD-1;i++){
			x = ((array.get(i).get(0)*10)+(array.get(i-1).get(0)*4)+(array.get(i+1).get(0)*4)+(array.get(i-1).get(1))+(array.get(i).get(1)*4)+(array.get(i+1).get(1)))/24;
			array2.get(i).set(0,x);
			for(int j=1;j<TD-1;j++){
				x = ((array.get(i-1).get(j-1))+(array.get(i-1).get(j)*4)+(array.get(i-1).get(j+1))+(array.get(i).get(j-1)*4)+(array.get(i).get(j)*10)+(array.get(i).get(j+1)*4)+(array.get(i+1).get(j+1))+(array.get(i+1).get(j)*4)+(array.get(i+1).get(j+1)))/30;
				array2.get(i).set(j,x);
			}
			x = ((array.get(i).get(TD-1)*10)+(array.get(i-1).get(TD-1)*4)+(array.get(i+1).get(TD-1)*4)+(array.get(i-1).get(TD-2))+(array.get(i).get(TD-2)*4)+(array.get(i+1).get(TD-2)))/24;
			array2.get(i).set(TD-1,x);
			if(i%1024 == 0){
				System.out.print('.');
			}
		}
		x = ((array.get(TD-1).get(0)*10)+(array.get(TD-1).get(1)*4)+(array.get(TD-2).get(0)*4)+(array.get(TD-2).get(1)))/19;
		array2.get(TD-1).set(0,x);
		for(int j=1;j<TD-1;j++){
			x = ((array.get(TD-1).get(j)*10)+(array.get(TD-1).get(j-1)*4)+(array.get(TD-1).get(j+1)*4)+(array.get(TD-2).get(j-1))+(array.get(TD-2).get(j)*4)+(array.get(TD-2).get(j+1)))/24;
			array2.get(TD-1).set(j,x);
		}
		x = ((array.get(TD-1).get(TD-1)*10)+(array.get(TD-1).get(TD-2)*4)+(array.get(TD-2).get(TD-1)*4)+(array.get(TD-2).get(TD-2)))/19;
		array2.get(TD-1).set(TD-1,x);
		System.out.print(".");
		return array2;
	}
}