package openfrontiers;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JProgressBar;
import javax.swing.JTextArea;

import static openfrontiers.builtins.*;
import openfrontiers.game.plane;
import openfrontiers.game.util.tile;

public abstract class wgen{
	//Constants defined in oflib
	public final static int blur_displacement = oflib.blur_displacement; //Determines the number of blocks displaced after smooth
	public final static int TD = oflib.dim_total;
	public final static int RD = oflib.dim_tile;
	
	//Static components defined by menu
	public static JProgressBar bar = menu.bar;
	public static JTextArea seed_box = menu.seed_box;
	public static JButton enter_seed_btn = menu.enter_seed_btn;
	public static JFrame widget = menu.widget;

	//Variables used in wgen
	public static plane world;
	public static ArrayList<ArrayList<Integer>> array0,array1,array2;

	
	public static plane gen(String seed){
		System.out.println("Seed: "+seed);
		world = new plane(seed);
		System.out.print("Generating heightmap");
		array0 = matrix2(TD+1,TD+1);
		array0.get(0).set(0,world.prnd());
		array0.get(0).set((int) TD,world.prnd());
		array0.get((int) TD).set(0, world.prnd());
		array0.get((int) TD).set((int) TD,world.prnd());
		hmap(0,0,TD,TD,0);
		array1 = matrix2(TD,TD);
		for(int i=0;i<TD;i++){
			for(int j=0;j<TD;j++){
				int x = (array0.get(i).get(j)+array0.get(i).get(j+1)+array0.get(i+1).get(j)+array0.get(i+1).get(j+1))/4;
				array1.get(i).set(j,x);
			}
		}
		System.out.println(" done");
		array0.clear();
		System.out.print("Smoothing(#1).");
		array2 = oflib.gauss(array1);
		for(int i=0;i<TD;i++){
			for(int j=0;j<TD;j++){
				array2.get(i).set(j, array2.get(i).get(j)+blur_displacement);
			}
			if(i%1024==0){
				System.out.print(".");
			}
		}
		System.out.println(" done");
		int q = (TD/RD);
		int r = q*q;
//		System.out.println(q+" "+r);
		world.tiles = new tile[r];
		for(int t=0;t<r;t++){
			int tx = t%q;
			int tz = t/q;
			world.tiles[t] = new tile(t%q,t/q);
			for(int i=0;i<RD;i++){
				for(int j=0;j<RD;j++){
					ArrayList<Integer> data = new ArrayList<Integer>();
					int absx = (tx*RD)+i;
					int absy = (tz*RD)+j;
					int s = array1.get(absx).get(absy);
					for(int k=0;k<s;k++){
						data.add(1);
					}
					for(int k=s;k<array2.get(absx).get(absy);k++){
						data.add(2);
					}
					world.tiles[t].build(i, j, data);
				}
			}
//			System.out.println(tx+","+tz);
		}
		return world;
	}
	public static int a,b,c,d,ab,ac,bd,cd,abcd,i;
	public static final byte depth = (byte) (Math.log(TD)/Math.log(2));
	public static void hmap(long ax,long ay,long bx,long cy,int level){
		if(level == depth){
			i++;
			if(i%2097152 == 0){System.out.print('.');}
			return;}
		a = array0.get((int) ax).get((int) ay);
		b = array0.get((int) bx).get((int) ay);
		c = array0.get((int) ax).get((int) cy);
		d = array0.get((int) bx).get((int) cy);
		ab = (a+b)/2;
		ac = (a+c)/2;
		bd = (b+d)/2;
		cd = (c+d)/2;
		if(level<4){abcd = ((a+b+c+d)/4)+(7-(world.prnd()/16));}
		else{abcd = (a+b+c+d)/4;}
		array0.get((int) ((ax+bx)/2)).set((int) ay,ab);
		array0.get((int) ax).set((int) ((ay+cy)/2),ac);
		array0.get((int) bx).set((int) ((ay+cy)/2),bd);
		array0.get((int) ((ax+bx)/2)).set((int) cy,cd);
		array0.get((int) ((ax+bx)/2)).set((int) ((ay+cy)/2),abcd);
		hmap(ax,ay,(ax+bx)/2,(ay+cy)/2,level+1);
		hmap(ax,(ay+cy)/2,(ax+bx)/2,cy,level+1);
		hmap((ax+bx)/2,ay,bx,(ay+cy)/2,level+1);
		hmap((ax+bx)/2,(ay+cy)/2,bx,cy,level+1);
	}
}
